/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef OUTPUTBUILD_H
#define OUTPUTBUILD_H

#include "settings.h"

#include <gtkmm/main.h>
#include <gtkmm/treeview.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/box.h>
#include <gtkmm/image.h>
#include <gtkmm/liststore.h>
#include <glib.h>

// Class to add column to the build output ListStore
class OutputBuildColumns : public Gtk::TreeModel::ColumnRecord
{
public:
  OutputBuildColumns()  { add(col_text); add(col_color); }
  Gtk::TreeModelColumn<Glib::ustring> col_text, col_color;
};

class OutputBuild
{
public:
  OutputBuild();

  Gtk::TreeView* get_build_box();
  Gtk::ScrolledWindow* get_swin();

  bool run_command(Glib::ustring, Gtk::TreeView*, EnvironmentSettings*);
  void stop_build();

  void erase();
  void add_row(Glib::ustring, Glib::ustring);
  void update_output();

private:
  Gtk::TreeView *build_box;
  Gtk::ScrolledWindow *swin;

  OutputBuildColumns build_columns;
  Glib::RefPtr<Gtk::ListStore> build_model;
  Gtk::CellRendererText *renderer;
  Gtk::TreeModel::Row row;
  Gtk::TreeViewColumn *color_column;

  bool continue_build;
};

#endif
