/***************************************************************************
 *   Copyright (C) 2005 by Andrew Krause                                   *
 *   Based on work by The gtkmm Development Team                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SOURCELANGUAGE_H
#define SOURCELANGUAGE_H

#include <glibmm.h>
#include <gtkmm/object.h>

typedef struct _GtkSourceLanguage GtkSourceLanguage;
typedef struct _GtkSourceLanguageClass GtkSourceLanguageClass;

namespace Gtk
{ class SourceLanguage_Class; 
}

namespace Gtk
{
  class SourceLanguage : public Glib::Object
  {
  public:
    typedef SourceLanguage CppObjectType;
    typedef SourceLanguage_Class CppClassType;
    typedef GtkSourceLanguage BaseObjectType;
    typedef GtkSourceLanguageClass BaseClassType;
  
    explicit SourceLanguage(const Glib::ConstructParams& construct_params);
    explicit SourceLanguage(GtkSourceLanguage* castitem);

    SourceLanguage();
    virtual ~SourceLanguage();

    static GType get_type()      G_GNUC_CONST;
    static GType get_base_type() G_GNUC_CONST;

    GtkSourceLanguage*       gobj()       { return reinterpret_cast<GtkSourceLanguage*>(gobject_); }
    const GtkSourceLanguage* gobj() const { return reinterpret_cast<GtkSourceLanguage*>(gobject_); }

    GtkSourceLanguage* gobj_copy();

  private:
    friend class SourceLanguage_Class;
    static CppClassType sourcelanguage_class_;

    SourceLanguage(const SourceLanguage&);
    SourceLanguage& operator=(const SourceLanguage&);
  };
}

namespace Glib
{
  Glib::RefPtr<Gtk::SourceLanguage> wrap(GtkSourceLanguage* object, bool take_copy = false);
}
#endif
